#pragma once
#include "printf.h"

#define EXPECT_FALSE(X)     __builtin_expect(!!(X), 0)
#define EXPECT_TRUE(X)      __builtin_expect(!!(X), 1)
#define FAIL                __builtin_trap()
#define REGPARAM(X)         __attribute__((regparm(X)))
#define NORETURN            __attribute__((noreturn))
#define ALWAYS_INLINE       __attribute__((always_inline)) inline
#define ALIGNED(X)          __attribute__((aligned(X)))

#ifdef NDEBUG
#define assert(X) (X)
#else
#define assert(X)   do { if (EXPECT_FALSE (!(X))) { printf ("assertion '%s' failed at %s:%u\n",#X,__FILE__,__LINE__); FAIL; } } while (0);
#endif
