#pragma once

#include "types.h"
#include "x86.h"

uint32 random_seed, random_inc; 
 
ALWAYS_INLINE 
static void srandom() 
{   
    rdtsc (random_seed, random_inc); 
} 
 
ALWAYS_INLINE 
static void srandom (uint32 s, uint32 i) 
{   
    random_seed = s; 
    random_inc  = i; 
}

ALWAYS_INLINE
static unsigned random()
{   
    // XXX race, but we don't care right now
    // XXX maybe sync to get "less random" behaviour (sequence would be fixed, but scheduling still varies)
    return random_seed = rol(random_seed) + random_inc;
}
