#pragma once

#include "compiler.h"
#include "types.h"

ALWAYS_INLINE
static void lfence() { asm volatile ("lfence" : : : "memory"); }

ALWAYS_INLINE
static void sfence() { asm volatile ("sfence" : : : "memory"); }

ALWAYS_INLINE
static void mfence() { asm volatile ("mfence" : : : "memory"); }

ALWAYS_INLINE
static uint64 rdtsc()
{
    uint64 i;
    asm volatile ("rdtsc" : "=A"(i));
    return i;
}

ALWAYS_INLINE
static void rdtsc(uint32& d, uint32& a)
{
    asm volatile ("rdtsc" : "=a" (a), "=d" (d));
}

ALWAYS_INLINE
static void rdtscp(uint32& d, uint32& a, uint32& c)
{
    asm volatile ("rdtscp" : "=a" (a), "=d" (d), "=c" (c));
}

ALWAYS_INLINE
static uint64 rdpmc (uint32 index)
{
    uint64 v;
    asm volatile ("rdpmc" : "=A"(v) : "c"(index));
    return v;
}

ALWAYS_INLINE
static void cpuid (unsigned fn, uint32& a, uint32& b, uint32& c, uint32& d)
{
        asm volatile ("cpuid" : "=a" (a), "=b" (b), "=c" (c), "=d" (d) : "a" (fn));
}

ALWAYS_INLINE
static uint32 rol (uint32 v)
{
    asm volatile ( "rol %0" : "=r"(v) : "0" (v));
    return v;
}
