#include "mem.h"

void *memset (void *s, int c, unsigned n) {
    char* s2 = static_cast<char*> (s);
    char c2 = c;

    while (n--)
        *s2++ = c2;

    return s;
}

void *memmove (void *dest, const void *src, unsigned n) {
    const char* src2 = static_cast<const char*> (src);
    char* dest2 = static_cast<char*> (dest);

    if (dest2 < src2) {

        while (n--)
            *dest2++ = *src2++;

    } else {

        src2 += n;
        dest2 += n;

        while (n--)
            *--dest2 = *--src2;

    }
    
    return dest;
}

void *memcpy (void *dest, const void *src, unsigned n) {
    return memmove (dest,src,n);
}
