#include "string.h"

unsigned strlen(const char *s)
{
    const char *t = s;
    for (; *t; ++t);
    return t - s;
}

char *strcpy(char *dest, const char *src)
{
    const char *p;
    char *q;

    for (p = src, q = dest; *p != '\0'; p++, q++)
        *q = *p;

    *q = '\0';

    return dest;
}

char *strncpy(char *dest, const char *src, unsigned n) {
    const char *p;
    char *q;

    for (p = src, q = dest; n && *p != '\0'; p++, q++, n--)
        *q = *p;

    for (; n; n--)
        *q = '\0';

    return dest;
}

char *strcat(char *dest, const char *src)
{
    char* const d = dest;
    while (*dest++) {}

    --dest;

    while ((*++dest = *src++)) {}

    return d;
}

int strcmp(const char *s1, const char *s2)
{
    for(; *s1 == *s2; ++s1, ++s2)
        if(*s1 == 0)
            return 0;

    return *s1 < *s2 ? -1 : 1;
}

int strncmp(const char *s1, const char *s2, unsigned n)
{
    for(; n && *s1 == *s2; --n, ++s1, ++s2)
        if(*s1 == 0)
            return 0;

    return n == 0 ? 0 : *s1 - *s2;
}
